#include "SQFuncs.h"
#include <stdio.h>

extern SQAPI sq;

_SQUIRRELDEF( HelloSquirrel )
{
	sq->pushstring( v, _SC( "Hello Squirrel Module!" ), -1 );

	return 1; /* return 0 indicates the Squirrel function does not return a value, 1 returns a value */
}

_SQUIRRELDEF( Sum )
{
	SQInteger iArgCount = sq->gettop( v ); /* Get the argument count */

	if ( iArgCount == 3 ) /* Argument count = 2 arguments + root table = 3 */
	{
		SQInteger i1 = 0, i2 = 0;

		sq->getinteger( v, 2, &i1 ); /* Get argument 1 in slot 2 to 'i1' */
		sq->getinteger( v, 3, &i2 ); /* Get argument 2 in slot 3 to 'i2' */

		sq->pushinteger( v, i1 + i2 ); /* Return the sum of these two numbers */
		return 1;
	}

	sq->pushbool( v, SQFalse );
	return 1;
}

SQInteger RegisterSquirrelFunc( HSQUIRRELVM v, SQFUNCTION f, const SQChar* fname, unsigned char ucParams, const SQChar* szParams )
{
	char szNewParams[ 32 ];

	sq->pushroottable( v );
	sq->pushstring( v, fname, -1 );
	sq->newclosure( v, f, 0 ); /* create a new function */

	if ( ucParams > 0 ) 
	{
		ucParams++; /* This is to compensate for the root table */
		
		sprintf( szNewParams, "t%s", szParams );

		sq->setparamscheck( v, ucParams, szNewParams ); /* Add a param type check */
	}

	sq->setnativeclosurename( v, -1, fname );
	sq->newslot( v, -3, SQFalse );
	sq->pop( v, 1 ); /* pops the root table */

	return 0;
}

void RegisterFuncs( HSQUIRRELVM v )
{
	/* Add your Squirrel functions here */

	RegisterSquirrelFunc( v, HelloSquirrel, "Hello", 0, 0 );
	RegisterSquirrelFunc( v, Sum, "Sum", 2, "ii" );
}
